JiscMail Logo
Email discussion lists for the UK Education and Research communities

Help for LCG-ROLLOUT Archives


LCG-ROLLOUT Archives

LCG-ROLLOUT Archives


LCG-ROLLOUT@JISCMAIL.AC.UK


View:

Message:

[

First

|

Previous

|

Next

|

Last

]

By Topic:

[

First

|

Previous

|

Next

|

Last

]

By Author:

[

First

|

Previous

|

Next

|

Last

]

Font:

Proportional Font

LISTSERV Archives

LISTSERV Archives

LCG-ROLLOUT Home

LCG-ROLLOUT Home

LCG-ROLLOUT  2005

LCG-ROLLOUT 2005

Options

Subscribe or Unsubscribe

Subscribe or Unsubscribe

Log In

Log In

Get Password

Get Password

Subject:

mass changes of SE hostname in LRC for NIKHEF!

From:

David Groep <[log in to unmask]>

Reply-To:

LHC Computer Grid - Rollout <[log in to unmask]>

Date:

Tue, 22 Mar 2005 12:55:39 +0100

Content-Type:

multipart/mixed

Parts/Attachments:

Parts/Attachments

text/plain (60 lines) , lcg-lrc-fixse (124 lines)

Hi all,

After the transition to the new farm at NIKHEF, the old storage
element front-end host is going to be decommissioned soon. The data
will just continue to be there, since it's hosted by a set of backend
servers, just the hostname will change.

For some (odd) reason, I can do that myself for all catalogues :-) No
security whatsoever, so sometime today I propose we here run through
the catalogues and do the updates.

The script we will use for that is included below for everyones scrutiny
(it's in turn generated by a perl script that runs though all catalogues
for all VOs looking for specific mappingsByPfn).

Any problems to be expetced with this operation?

        Cheers,
        DavidG.


--- example of perl-script output, to be run by /bin/sh ---
update_lrc() {
   # syntax: update_lrc $vo $guido $oldsfn $newsfn
   lcg-rf --vo $1 -g $2 $4
   if [ $? -ne 0 ]; then
     echo "Failed to register new PFN for $2: error $?" >&2
     exit 1
   fi
   match=`lcg-lr --vo $1 $2 | grep -c "$4"`
   if [ $match -eq 0 ]; then
     echo "Catalogue failure for $2: lost entry after insert" >&2
     exit 1
   else
     lcg-uf --vo $1 $2 $3
     if [ $? -ne 0 ]; then
       echo "Failed to UNregister old PFN for $2: error $?" >&2
       exit 1
     fi
   fi;
}

update_lrc esr guid:2aaf6635-0ca7-11d9-8789-8254ae2c0f36 \
sfn://tbn17.nikhef.nl/datastore2/esr/generated/2004-09-22/file20209c24-0ca7-11d9-8789-8254ae2c0f36
  \
sfn://tbn15.nikhef.nl/datastore2/esr/generated/2004-09-22/file20209c24-0ca7-11d9-8789-8254ae2c0f36
update_lrc esr ...
...


The generator script for this script is attached :-)


--
David Groep

** National Institute for Nuclear and High Energy Physics, PDP/Grid group **
** Room: H1.56 Phone: +31 20 5922179, PObox 41882, NL-1009DB Amsterdam NL **



#! /usr/bin/perl # # @(#)$Id$ # # lcg-lrc-fixse: a quick hack to update the PFNs in all LRC catalogues # whenever a hostname changes # use Net::LDAP qw(:all); # change these setting to match your local BDII $bdii="boswachter.nikhef.nl:2170"; @vos = qw( atlas alice lhcb cms pvier astron astrop esr            eo biome magic asci dzero ); # what has to be changed? From $oldpath to $newpath! $oldpath="sfn://tbn17.nikhef.nl"; $newpath="sfn://tbn15.nikhef.nl"; ############################################################################## # retrieve all RLS endpoints, assuming that the VO name for the ACL # is the same as the VO name for the RLS instances # $serverbase="Mds-Vo-name=local,o=Grid"; my $hldap = Net::LDAP->new($bdii); my $result = $hldap->search(       base=>"$serverbase",       scope=>"sub",       filter=>'(GlueServiceType=edg-local-replica-catalog)',       attrs=>["GlueServiceAccessPointURL","GlueServiceAccessControlRule"]     ); my @entries = $result->entries; @entries or die "Did not find LRC endpoints in $serverbase on $ldapserver\n"; # this hash needed to find duplicate guids in broken catalogue setups %guid=(); ############################################################################## # output the shell function first, to be used lated by the # generated update_lrc commands # print <<EOF; update_lrc() {   # syntax: update_lrc \$vo \$guido \$oldsfn \$newsfn   lcg-rf --vo \$1 -g \$2 \$4   if [ \$? -ne 0 ]; then     echo "Failed to register new PFN for \$2: error \$?" >&2     exit 1   fi   match=`lcg-lr --vo \$1 \$2 | grep -c "\$4"`   if [ \$match -eq 0 ]; then     echo "Catalogue failure for \$2: lost entry after insert" >&2     exit 1   else     lcg-uf --vo \$1 \$2 \$3     if [ \$? -ne 0 ]; then       echo "Failed to UNregister old PFN for \$2: error \$?" >&2       exit 1     fi   fi; } EOF ############################################################################## # iterate over all VOs found there # foreach $entr ( @entries ) {     my $dn = $entr->dn();     my $ep = $entr->get_value("GlueServiceAccessPointURL");     my $vo = $entr->get_value("GlueServiceAccessControlRule");     $maxres = 10;     my $dothis=0;     my $v;     foreach $v ( @vos ) { ($vo =~ /^$v$/) and $dothis++; };     $dothis or next;     print "# DN: $dn\n";     print "# endpoint = $ep\n";     print "# vo = $vo\n";     #####################################################################     # find maximum number of entries to query     #     $cmd="edg-lrc metadata --endpoint $ep";     open LRC,"$cmd 2>&1|" or die "Cannot execute LRC command for VO $vo: $!\n";     while (<LRC>) {       chomp($_); split;       /Total number of GUIDs/ and $maxres=($maxres<$_[$#_]?$_[$#_]:$maxres+1);       /Total number of PFNs/ and $maxres=($maxres<$_[$#_]?$_[$#_]:$maxres+1);     }     close LRC;     print "# VO $vo: maximum PFNs/GUIDs is $maxres\n";     #####################################################################     # for every VO, find the list of guids that have an SFN entry on     # the $oldpath and generate the lcg-rf/uf commands to move that     #     $cmd="edg-lrc mappingsByPfn --endpoint $ep --length $maxres ";     $cmd.="$oldpath\*";     open LRC,"$cmd 2>&1|" or die "Cannot execute LRC command for VO $vo: $!\n";     while (<LRC>) {       chomp($_);       /^There might be more mappings/ and           warn "# VO $vo: too many mappings\n";       my ($guid,$sfn) = split(/,\s+/,$_,2);       # remove duplicate guids in case of broken RLS setup       if ($guid{$guid}) {         print "# Duplicate GUID $vo (from ".$guid{$guid}."): $guid\n";         next;       }       $guid{$guid}=$vo;       (my $nsfn=$sfn) =~ s $oldpath $newpath m;       print "update_lrc $vo $guid $sfn $nsfn\n";     }     close LRC; }

Top of Message | Previous Page | Permalink

JiscMail Tools


RSS Feeds and Sharing


Advanced Options


Archives

April 2024
March 2024
November 2023
June 2023
May 2023
April 2023
March 2023
February 2023
September 2022
June 2022
May 2022
April 2022
February 2022
December 2021
November 2021
October 2021
September 2021
July 2021
June 2021
May 2021
February 2021
January 2021
November 2020
September 2020
August 2020
July 2020
June 2020
May 2020
April 2020
March 2020
February 2020
January 2020
November 2019
October 2019
September 2019
August 2019
July 2019
June 2019
May 2019
March 2019
February 2019
January 2019
December 2018
November 2018
October 2018
September 2018
August 2018
July 2018
June 2018
May 2018
April 2018
February 2018
January 2018
November 2017
October 2017
September 2017
July 2017
June 2017
May 2017
March 2017
February 2017
January 2017
December 2016
November 2016
October 2016
September 2016
August 2016
July 2016
June 2016
May 2016
April 2016
March 2016
February 2016
January 2016
December 2015
November 2015
October 2015
September 2015
August 2015
July 2015
June 2015
May 2015
April 2015
March 2015
February 2015
January 2015
December 2014
November 2014
October 2014
September 2014
August 2014
July 2014
June 2014
May 2014
April 2014
March 2014
February 2014
January 2014
December 2013
November 2013
October 2013
September 2013
August 2013
July 2013
June 2013
May 2013
April 2013
March 2013
February 2013
January 2013
December 2012
November 2012
October 2012
September 2012
August 2012
July 2012
June 2012
May 2012
April 2012
March 2012
February 2012
January 2012
December 2011
November 2011
October 2011
September 2011
August 2011
July 2011
June 2011
May 2011
April 2011
March 2011
February 2011
January 2011
December 2010
November 2010
October 2010
September 2010
August 2010
July 2010
June 2010
May 2010
April 2010
March 2010
February 2010
January 2010
December 2009
November 2009
October 2009
September 2009
August 2009
July 2009
June 2009
May 2009
April 2009
March 2009
February 2009
January 2009
December 2008
November 2008
October 2008
September 2008
August 2008
July 2008
June 2008
May 2008
April 2008
March 2008
February 2008
January 2008
December 2007
November 2007
October 2007
September 2007
August 2007
July 2007
June 2007
May 2007
April 2007
March 2007
February 2007
January 2007
2006
2005
2004
2003


JiscMail is a Jisc service.

View our service policies at https://www.jiscmail.ac.uk/policyandsecurity/ and Jisc's privacy policy at https://www.jisc.ac.uk/website/privacy-notice

For help and support help@jisc.ac.uk

Secured by F-Secure Anti-Virus CataList Email List Search Powered by the LISTSERV Email List Manager